#pragma once

class Checksum {
    public:
       Checksum() { Initialize(); }
       void Initialize() { sum = 0;}
       void Add(CComboBox & ctl)
               {
                int sel = ctl.GetCurSel();
                if(sel != CB_ERR)
                   { /* add it */
                    CString s;
                    ctl.GetLBText(sel, s);
                    Add(s);
                   } /* add it */
               }

       void Add(CCheckListBox & ctl)
               { 
                for(int i = 0; i < ctl.GetCount(); i++)
                   { /* add each */
                    CString s;
                    ctl.GetText(i, s);
                    Add(s);
                    int n = ctl.GetCheck(i);
                    Add(i);
                   } /* add each */
               }
                
       void Add(BYTE b) { BYTE cipher;
                          cipher = (BYTE)((b ^ (sum >> 8)));
                          sum = (cipher + sum) * c1 + c2;
                        }
       void Add(DWORD x) {
                        Add((BYTE) (x & 0xFF));
                        Add((BYTE) ((x >> 8) & 0xFF));
                        Add((BYTE) ((x >> 16) & 0xFF));
                        Add((BYTE) ((x >> 24) & 0xFF));
                       }
       void Add(int x) { Add( (DWORD) x ); }
       void Add(LPCTSTR s) {
                            while(*s != _T('\0'))
                               { /* scan string */
                                Add( (BYTE)*s );
                                s++;
                               } /* scan string */
                           }
       void Add(float f) {
                          union { float f; DWORD v; } val;
                          val.f = f;
                          Add(val.v);
                         }
       void Add(double d) {
                           union {double d; struct { DWORD A; DWORD B; } v; } val;
                           val.d = d;
                           Add(val.v.A);
                           Add(val.v.B);
                          }
       BOOL operator ==(const Checksum & p) const {return p.sum == sum; }
       BOOL operator !=(const Checksum & p) const {return p.sum != sum; }
       const Checksum & operator =(const Checksum & p) { sum = p.sum; return p; }
    protected:
       static const WORD c1;
       static const WORD c2;
       DWORD sum;
};
