#pragma once

class Error {
    public:
       Error() {line = 0; column = 0; }
       Error(const CString & s) { line = 0; column = 0; text = s;}
       Error(int L, int C, const CString & s) {line = L; column = C; text = s; }
               //****************************************************************
               // MakeString
               //****************************************************************
       CString MakeString() {
          CString s;
          if(line == 0 && column == 0)
             return text;
          s.Format(_T("[%03d,%03d] %s"), line, column, text);
          return s;
       }
               //****************************************************************
               // SplitString
               //****************************************************************
       void SplitString(const CString & s) {
          if(s[0] == _T('['))
             { /* has line info */
              CString t;
              int comma = s.Find(_T(","));
              if(comma < 0)
                 { /* failed */
                  line = column = 0;
                  text = s;
                  return;
                 } /* failed */
              t = s.Mid(1, comma - 1);
              line = atoi(t);
              int rb = s.Find(_T("]"));
              t = s.Mid(comma + 1, rb - (comma + 1));
              column = atoi(t);
              text = s.Mid(rb + 1);
              text.TrimLeft();
             } /* has line info */
          else
             { /* no line info */
              line = column = 0;
              text = s;
             } /* no line info */
       }
            //****************************************************************
            // NoPos
            //****************************************************************
       BOOL NoPos() { return (line == 0 && column == 0); }
            //****************************************************************
            // Data
            //****************************************************************
    public:
       int line;
       int column;
       CString text;
};
