// ErrorSummary.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ErrorSummary.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CErrorSummary

CErrorSummary::CErrorSummary()
   {
    images = NULL;
   }

CErrorSummary::~CErrorSummary()
{
}


BEGIN_MESSAGE_MAP(CErrorSummary, CSmartDropdown)
        //{{AFX_MSG_MAP(CErrorSummary)
        ON_CONTROL_REFLECT(CBN_CLOSEUP, OnCloseup)
        ON_WM_RBUTTONDOWN()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CErrorSummary message handlers

int CErrorSummary::CompareItem(LPCOMPAREITEMSTRUCT cis) 
{
        // TODO: Add your code to determine the sorting order of the specified items
        // return -1 = item 1 sorts before item 2
        // return 0 = item 1 and item 2 sort the same
        // return 1 = item 1 sorts after item 2
        
        return 0;
}

/****************************************************************************
*                          CErrorSummary::DeleteItem
* Inputs:
*       LPDELETEITEMSTRUCT dis
* Result: void
*       
* Effect: 
*       Handles deletion of an item
****************************************************************************/

void CErrorSummary::DeleteItem(LPDELETEITEMSTRUCT dis) 
{
        // TODO: Add your specialized code here and/or call the base class
        
        CComboBox::DeleteItem(dis);
}

/****************************************************************************
*                           CErrorSummary::DrawItem
* Inputs:
*       LPDRAWITEMSTRUCT dis:
* Result: void
*       
* Effect: 
*       Draws the entry.
* Notes:
*       [X] text
****************************************************************************/

void CErrorSummary::DrawItem(LPDRAWITEMSTRUCT dis) 
   {
    CRect r = dis->rcItem;
    CDC * dc = CDC::FromHandle(dis->hDC);
    CBrush br;
    CBrush * oldbrush;
    COLORREF txcolor;
    COLORREF bkcolor;

    if(dis->itemState & ODS_SELECTED)
       { /* selected */
        bkcolor = GetSysColor(COLOR_HIGHLIGHT);
        txcolor = GetSysColor(COLOR_HIGHLIGHTTEXT);
       } /* selected */
    else
       { /* unselected */
        if(dis->itemState & (ODS_DISABLED | ODS_GRAYED))
           txcolor = GetSysColor(COLOR_GRAYTEXT);
        else
           txcolor = GetSysColor(COLOR_WINDOWTEXT);

        bkcolor = GetSysColor(COLOR_WINDOW);
       } /* unselected */

    dc->SetBkColor(bkcolor);
    dc->SetTextColor(txcolor);

    br.CreateSolidBrush(bkcolor);
    oldbrush = dc->SelectObject(&br);

    dc->PatBlt(r.left, r.top, r.Width(), r.Height(), PATCOPY);

    dc->SelectObject(oldbrush);
    br.DeleteObject();

    if(dis->itemID != (UINT)-1 
       && (dis->itemState & (ODS_DISABLED | ODS_GRAYED)) == 0)
       { /* has item */

        if(images != NULL)
           { /* draw image */
            int ix = (int)dis->itemData;
            images->Draw(dc, ix, CPoint(r.left, r.top), ILD_NORMAL);
           } /* draw image */

        r.left += 16;
        CSize w = dc->GetTextExtent(_T(" "), 1);
        r.left += w.cx;

        CString s;
        GetLBText(dis->itemID, s);

        dc->TextOut(r.left, r.top, s);
       } /* has item */

    if(dis->itemState & ODS_FOCUS && dis->itemAction != ODA_SELECT)
       dc->DrawFocusRect(&r);

   }

/****************************************************************************
*                          CErrorSummary::OnCloseup
* Result: void
*       
* Effect: 
*       On close-up forces the selection back to seleciton 0
****************************************************************************/

void CErrorSummary::OnCloseup() 
   {
    SetCurSel(0);
   }

/****************************************************************************
*                          CErrorSummary::AddString
* Inputs:
*       Error & error: Error descriptor
*       ErrorIcons::icon code: Error level code
* Result: int
*       Place where it was inserted
* Effect: 
*       Adds the new error object
****************************************************************************/

int CErrorSummary::AddString(Error & error, ErrorIcons::icon code)
    {
     int result = FindStringExact(-1, error.text);
     if(result != CB_ERR)
        return result; // already in place.

     result = CSmartDropdown::AddString(error.text);
     CSmartDropdown::SetItemData(result, (DWORD)code);
     return result;
    } // CErrorSummary::AddString

/****************************************************************************
*                        CErrorSummary::OnRButtonDown
* Inputs:
*       UINT nFlags:
*       CPoint point:
* Result: void
*       
* Effect: 
*       Pops up a notification about adding to filter list, or
*       some other operation
****************************************************************************/

void CErrorSummary::OnRButtonDown(UINT nFlags, CPoint point) 
   {
    int n = CSmartDropdown::GetCurSel();
    if(n == CB_ERR)
       return; // should not occur
    if(n == 0)
       return; // special case: ignore item 0

    CMenu menu;
    menu.LoadMenu(IDR_ERROR_POPUP);
    CMenu * popup = menu.GetSubMenu(0);

    CPoint pt;
    GetCursorPos(&pt);

    popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, pt.x, pt.y, GetParent());

    // CSmartDropdown::OnRButtonDown(nFlags, point);
   }
