#pragma once

#include "Checksum.h"

class FilterInfo {
    public:
       FilterInfo() { enabled = FALSE; }
       FilterInfo(CString t, BOOL e) { text = t; enabled = e; }
       AFX_INLINE CString GetText() { return text; }
       AFX_INLINE BOOL GetEnabled() {return enabled; }
    public:
       Checksum computeChecksum() {
          Checksum chk;
          chk.Add(enabled);
          chk.Add(text);
          return chk;
       }
    protected:
       CString text;
       BOOL enabled;
};

class Filter {
    public:
       BOOL Find(const CString & s);
       int Add(const CString & s, BOOL enable = TRUE);
       BOOL IsFiltered(const CString & s);
       CString GetText(int i) { return table[i].GetText(); }
       BOOL GetEnabled(int i) { return table[i].GetEnabled(); }
       int GetSize() { return table.GetSize(); }
       void RemoveAll() { table.RemoveAll(); }
       BOOL Save(CString & filename);
       BOOL Load(const CString & filename);
       BOOL GetModify();
       void SetState();
       void SetModify(BOOL mode = TRUE);
    protected:
       Checksum computeChecksum();
       CArray<FilterInfo, FilterInfo&> table;
       Checksum chksum;
};
