// Filters.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Filters.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilters dialog


CFilters::CFilters(CWnd* pParent /*=NULL*/)
        : CDialog(CFilters::IDD, pParent)
{
        //{{AFX_DATA_INIT(CFilters)
        //}}AFX_DATA_INIT
}


void CFilters::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CFilters)
        DDX_Control(pDX, IDC_DELETE, c_Delete);
        DDX_Control(pDX, IDC_FILTERS, c_Filters);
        DDX_Control(pDX, IDC_ENABLE_ALL, c_EnableAll);
        DDX_Control(pDX, IDC_DISABLE_ALL, c_DisableAll);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFilters, CDialog)
        //{{AFX_MSG_MAP(CFilters)
        ON_WM_SIZE()
        ON_LBN_SELCHANGE(IDC_FILTERS, OnSelchangeFilters)
        ON_BN_CLICKED(IDC_DELETE, OnDelete)
        ON_BN_CLICKED(IDC_DISABLE_ALL, OnDisableAll)
        ON_BN_CLICKED(IDC_ENABLE_ALL, OnEnableAll)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilters message handlers

BOOL CFilters::OnInitDialog() 
   {
    CDialog::OnInitDialog();
        
    ASSERT(filters != NULL);
    for(int i = 0; i < filters->GetSize(); i++)
       { /* scan elements */
        int n = c_Filters.AddString(filters->GetText(i));
        c_Filters.SetCheck(n, filters->GetEnabled(i));
       } /* scan elements */
        
    updateControls();
        
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                              CFilters::OnSize
* Inputs:
*       UINT nType: Type of resize
*       int cx: New width
*       int cy: New height
* Result: void
*       
* Effect: 
*       Handles resize of the dialog
****************************************************************************/

void CFilters::OnSize(UINT nType, int cx, int cy) 
   {
    CDialog::OnSize(nType, cx, cy);
        
    if(c_Filters.GetSafeHwnd() != NULL)
       { /* resize list */
        CRect r;
        c_Filters.GetWindowRect(&r);
        ScreenToClient(&r);
        c_Filters.SetWindowPos(NULL,
                               0,0,
                               cx, cy - r.top,
                               SWP_NOMOVE | SWP_NOZORDER);
       } /* resize list */
        
   }

/****************************************************************************
*                          CFilters::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CFilters::updateControls()
    {
     BOOL empty = c_Filters.GetCount() == 0;
     c_EnableAll.EnableWindow(!empty);
     c_DisableAll.EnableWindow(!empty);

     int sel = c_Filters.GetCurSel();
     c_Delete.EnableWindow(sel != LB_ERR);
    } // CFilters::updateControls

/****************************************************************************
*                        CFilters::OnSelchangeFilters
* Result: void
*       
* Effect: 
*       Updates controls
****************************************************************************/

void CFilters::OnSelchangeFilters() 
   {
    updateControls();
   }

/****************************************************************************
*                             CFilters::OnDelete
* Result: void
*       
* Effect: 
*       Deletes selected elements
****************************************************************************/

void CFilters::OnDelete() 
   {
    int n = c_Filters.GetCurSel();
    if(n == LB_ERR)
       return;

    c_Filters.DeleteString(n);
    updateControls();
   }

/****************************************************************************
*                               CFilters::OnOK
* Result: void
*       
* Effect: 
*       Updates the filter list
****************************************************************************/

void CFilters::OnOK() 
   {
    filters->RemoveAll();
        
    for(int i = 0; i < c_Filters.GetCount(); i++)
       { /* refill */
        CString s;
        BOOL enabled;
        c_Filters.GetText(i, s);
        enabled = c_Filters.GetCheck(i);
        filters->Add(s, enabled);
       } /* refill */

    CDialog::OnOK();
   }


/****************************************************************************
*                            CFilters::OnDisableAll
* Result: void
*       
* Effect: 
*       Enables all filters
****************************************************************************/

void CFilters::OnDisableAll() 
   {
    for(int i = 0; i < c_Filters.GetCount(); i++)
       { /* disable */
        c_Filters.SetCheck(i, BST_UNCHECKED);
       } /* disable */
   }

/****************************************************************************
*                            CFilters::OnEnableAll
* Result: void
*       
* Effect: 
*       Enables all filters
****************************************************************************/

void CFilters::OnEnableAll() 
   {
    for(int i = 0; i < c_Filters.GetCount(); i++)
       { /* enable */
        c_Filters.SetCheck(i, BST_CHECKED);
       } /* enable */
   }
