// MultiTidyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MultiTidy.h"
#include "MultiTidyDlg.h"
#include "RegVars.h"
#include "ErrorString.h"
#include "platform.h"
#include "tidy.h"
#include "buffio.h"
#include "Filters.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define MIN_WINDOW_SIZE (3 * ::GetSystemMetrics(SM_CYCAPTION))
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        //{{AFX_DATA(CAboutDlg)
        enum { IDD = IDD_ABOUTBOX };
        //}}AFX_DATA

        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CAboutDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        //{{AFX_MSG(CAboutDlg)
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
        //{{AFX_DATA_INIT(CAboutDlg)
        //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CAboutDlg)
        //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
        //{{AFX_MSG_MAP(CAboutDlg)
                // No message handlers
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiTidyDlg dialog

CMultiTidyDlg::CMultiTidyDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CMultiTidyDlg::IDD, pParent)
{
        //{{AFX_DATA_INIT(CMultiTidyDlg)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
        // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
        UseFilters = TRUE;
}

void CMultiTidyDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CMultiTidyDlg)
        DDX_Control(pDX, IDC_SUMMARY, c_ErrorSummary);
        DDX_Control(pDX, IDC_TITLE, c_Title);
        DDX_Control(pDX, IDC_ERROR_MSG, c_ErrorMessage);
        DDX_Control(pDX, IDC_CHANGE_FLAG, c_Changed);
        DDX_Control(pDX, IDC_PROGRESS, c_Progress);
        DDX_Control(pDX, IDC_TEXT, c_Text);
        DDX_Control(pDX, IDC_DIRECTORY, c_Directory);
        //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMultiTidyDlg, CDialog)
        //{{AFX_MSG_MAP(CMultiTidyDlg)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        ON_WM_CLOSE()
        ON_WM_SIZE()
        ON_WM_GETMINMAXINFO()
        ON_NOTIFY(NM_DBLCLK, IDC_DIRECTORY, OnDblclkDirectory)
        ON_NOTIFY(TVN_DELETEITEM, IDC_DIRECTORY, OnDeleteitemDirectory)
        ON_COMMAND(IDM_ABOUT, OnAbout)
        ON_COMMAND(IDM_EXIT, OnExit)
        ON_COMMAND(IDM_OPEN, OnOpen)
        ON_COMMAND(IDM_TIDY, OnTidy)
        ON_COMMAND(IDM_FILE_CLEAR, OnFileClear)
        ON_WM_INITMENUPOPUP()
        ON_WM_SETCURSOR()
        ON_WM_LBUTTONDOWN()
        ON_WM_LBUTTONUP()
        ON_WM_MOUSEMOVE()
        ON_NOTIFY(NM_RCLICK, IDC_DIRECTORY, OnRclickDirectory)
        ON_COMMAND(IDM_SHOW, OnShow)
        ON_COMMAND(IDM_IGNORE, OnIgnore)
        ON_EN_CHANGE(IDC_TEXT, OnChangeText)
        ON_COMMAND(IDM_SAVE, OnSave)
        ON_COMMAND(IDM_EDIT_FILTERS, OnEditFilters)
        ON_COMMAND(IDM_EXPAND_ALL, OnExpandAll)
        ON_COMMAND(IDM_FILTER, OnFilter)
        ON_COMMAND(IDM_USE_FILTERS, OnUseFilters)
        ON_COMMAND(IDM_DELETE_MSG, OnDeleteMsg)
        ON_COMMAND(IDM_REMOVE_FILE, OnRemoveFile)
        ON_COMMAND(IDM_REPLACE, OnReplace)
        ON_COMMAND(IDM_RETIDY, OnRetidy)
        ON_COMMAND(IDM_CLOSE, OnCloseFile)
        ON_COMMAND(IDM_SAVE_THIS_AS, OnSaveThisAs)
        ON_COMMAND(IDM_SAVE_THIS, OnSaveThis)
        ON_COMMAND(IDM_TIDY_THIS, OnTidyThis)
        ON_COMMAND(IDM_SAVE_FILTERS, OnSaveFilters)
        ON_COMMAND(IDM_EXPAND_ERRORS, OnExpandErrors)
        ON_COMMAND(IDM_COLLAPSE_ERRORS, OnCollapseErrors)
        ON_COMMAND(IDM_DROP_CLEAN, OnDropClean)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiTidyDlg message handlers

BOOL CMultiTidyDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        // Add "About..." menu item to system menu.

        // IDM_ABOUTBOX must be in the system command range.
        ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
        ASSERT(IDM_ABOUTBOX < 0xF000);

        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
        {
                CString strAboutMenu;
                strAboutMenu.LoadString(IDS_ABOUTBOX);
                if (!strAboutMenu.IsEmpty())
                {
                        pSysMenu->AppendMenu(MF_SEPARATOR);
                        pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
                }
        }

        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);                 // Set big icon
        SetIcon(m_hIcon, FALSE);                // Set small icon
        
        // TODO: Add extra initialization here
        c_Progress.ShowWindow(SW_HIDE);

        dragger = AfxGetApp()->LoadCursor(IDC_DRAGGER);
        drag = AfxGetApp()->LoadCursor(IDC_DRAG);

        imagelist.Create(IDB_ICONS, 16, 0, RGB(255, 0, 255));
        c_Directory.SetImageList(&imagelist, TVSIL_STATE);
        c_ErrorSummary.SetImageList(&imagelist);
        
        iconlist.Create(IDB_NODES, 16, 0, RGB(255, 0, 255));
        c_Directory.SetImageList(&iconlist, TVSIL_NORMAL);

        c_Text.SetEventMask(c_Text.GetEventMask() | ENM_CHANGE);

        c_ErrorMessage.SetWindowText(_T(""));
        c_Text.SetModify(FALSE);
        original = ComputeChecksum();

        c_Title.SetWindowText(_T(""));
        LOGFONT lf;
        ::ZeroMemory(&lf, sizeof(lf));

        CRect r;
        c_Title.GetClientRect(&r);
        ScreenToClient(&r);
        lf.lfHeight = r.Height();
        lstrcpy(lf.lfFaceName, _T("Arial"));
        lf.lfWeight = FW_BOLD;
        titlefont.CreateFontIndirect(&lf);
        c_Title.SetFont(&titlefont);
        
        RegistryString filter(IDS_REGISTRY_FILTERS);
        filter.load();
        if(!filter.value.IsEmpty())
           filters.Load(filter.value);

        updateControls();
        
        return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMultiTidyDlg::OnSysCommand(UINT nID, LPARAM lParam)
   {
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
       {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
       }
    else
       {
        CDialog::OnSysCommand(nID, lParam);
       }
   }

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMultiTidyDlg::OnPaint() 
   {
    if (IsIconic())
       {
        CPaintDC dc(this); // device context for painting
        
        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
       }
    else
       {
        CDialog::OnPaint();
       }
   }

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMultiTidyDlg::OnQueryDragIcon()
   {
    return (HCURSOR) m_hIcon;
   }

void CMultiTidyDlg::OnCancel() 
   {
   }

void CMultiTidyDlg::OnOK() 
   {
   }

void CMultiTidyDlg::OnClose() 
   {
    CDialog::OnOK();
   }

/****************************************************************************
*                      CMultiTidyDlg::SizeTextCompanions
* Result: void
*       
* Effect: 
*       Resizes the text companion windows
****************************************************************************/

void CMultiTidyDlg::SizeTextCompanions()
    {
     CRect c;
     GetClientRect(&c);

     if(c_ErrorMessage.GetSafeHwnd() != NULL && c_Text.GetSafeHwnd() != NULL)
        { /* resize error message text */
         CRect w;
         c_Text.GetWindowRect(&w);
         ScreenToClient(&w);
         CRect r;
         c_ErrorMessage.GetWindowRect(&r);
         ScreenToClient(&r);
         c_ErrorMessage.SetWindowPos(NULL,
                                     w.left, c.bottom - r.Height(),
                                     c.right - w.left, r.Height(),
                                     SWP_NOZORDER);
        } /* resize error message text */

     if(c_Title.GetSafeHwnd() != NULL && c_Text.GetSafeHwnd() != NULL)
        { /* resize title text */
         CRect w;
         c_Text.GetWindowRect(&w);
         ScreenToClient(&w);
         CRect r;
         c_Title.GetWindowRect(&r);
         ScreenToClient(&r);
         c_Title.SetWindowPos(NULL,
                              w.left, r.top,
                              c.right - w.left, r.Height(),
                              SWP_NOZORDER);
        } /* resize title text */
     
     if(c_ErrorSummary.GetSafeHwnd() != NULL)
        { /* resize error summary */
         CRect w;
         c_Directory.GetWindowRect(&w);
         ScreenToClient(&w);
         CRect r;
         c_ErrorSummary.GetWindowRect(&r);
         ScreenToClient(&r);
         c_ErrorSummary.SetWindowPos(NULL,
                                     0, 0, // do not move
                                     w.Width() - r.left, r.Height(),
                                     SWP_NOMOVE | SWP_NOZORDER);
        } /* resize error summary */
    } // CMultiTidyDlg::SizeTextCompanions

/****************************************************************************
*                            CMultiTidyDlg::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Resizes the windows
****************************************************************************/

void CMultiTidyDlg::OnSize(UINT nType, int cx, int cy) 
   {
    CDialog::OnSize(nType, cx, cy);
        
    if(c_Directory.GetSafeHwnd() != NULL)
       { /* resize directory window */
        CRect r;
        c_Directory.GetWindowRect(&r);
        ScreenToClient(&r);
        c_Directory.SetWindowPos(NULL,
                                 0, 0, // do not move
                                 r.Width(), cy - r.top,
                                 SWP_NOMOVE | SWP_NOZORDER);
       } /* resize directory window */

    if(c_Text.GetSafeHwnd() != NULL && c_ErrorMessage.GetSafeHwnd() != NULL)
       { /* resize text window */
        CRect w;
        c_ErrorMessage.GetWindowRect(&w);
        ScreenToClient(&w);
        CRect r;
        c_Text.GetWindowRect(&r);
        ScreenToClient(&r);
        c_Text.SetWindowPos(NULL,
                            0, 0, // do not move
                            cx - r.left, cy - r.top - w.Height(),
                            SWP_NOMOVE | SWP_NOZORDER);
       } /* resize text window */

    if(c_Progress.GetSafeHwnd() != NULL)
       { /* resize progress bar */
        CRect r;
        c_Progress.GetWindowRect(&r);
        ScreenToClient(&r);
        c_Progress.SetWindowPos(NULL,
                                0,0, // do not move
                                cx - r.left, r.Height(),
                                SWP_NOMOVE | SWP_NOZORDER);
       } /* resize progress bar */

    SizeTextCompanions();
   }

/****************************************************************************
*                       CMultiTidyDlg::OnGetMinMaxInfo
* Inputs:
*       MINMAXINFO FAR * lpMMI:
* Result: void
*       
* Effect: 
*       Limits the dynamic resize
****************************************************************************/

void CMultiTidyDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
   {
    if(c_Directory.GetSafeHwnd() != NULL)
       { /* limit size */
        CRect r;
        c_Text.GetWindowRect(&r);
        ScreenToClient(&r);

        
        lpMMI->ptMinTrackSize.x = r.left + MIN_WINDOW_SIZE;

        int n = 5 * ::GetSystemMetrics(SM_CYCAPTION);
        lpMMI->ptMinTrackSize.y = n;
       } /* limit size */
        
    CDialog::OnGetMinMaxInfo(lpMMI);
   }

/****************************************************************************
*                         CMultiTidyDlg::SetFileState
* Inputs:
*       HTREEITEM item: File item
*       ErrorIcons::icon state: New state to set
* Result: void
*       
* Effect: 
*       Sets the item state to the max of its current state and the new state
****************************************************************************/

void CMultiTidyDlg::SetFileState(HTREEITEM item, ErrorIcons::icon state)
    {
     UINT newstate = INDEXTOSTATEIMAGEMASK((UINT)state);

     UINT pstate = c_Directory.GetItemState(item, TVIS_STATEIMAGEMASK) & TVIS_STATEIMAGEMASK; // Documentation lies!
     if(newstate > pstate)
        c_Directory.SetItemState(item, newstate, TVIS_STATEIMAGEMASK);
    } // CMultiTidyDlg::SetFileState

/****************************************************************************
*                           CMultiTidyDlg::SetState
* Inputs:
*       HTREEITEM item: Item whose state is to be set
*       ErrorIcons::icon state: State to be set
* Result: void
*       
* Effect: 
*       Sets the state of the element in question, and of its parent, if
*       the parent state is less than the current state
****************************************************************************/

void CMultiTidyDlg::SetState(HTREEITEM item, ErrorIcons::icon state)
    {
     NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
     UINT newstate = INDEXTOSTATEIMAGEMASK((UINT)state);
     switch(data)
        { /* node type */
         case NodeType::File:
               c_Directory.SetItemState(item, newstate, TVIS_STATEIMAGEMASK);
               break;
         case NodeType::Message:
               c_Directory.SetItemState(item, newstate, TVIS_STATEIMAGEMASK);
               SetFileState(c_Directory.GetParentItem(item), state);
               break;
        } /* node type */
    } // CMultiTidyDlg::SetState

/****************************************************************************
*                      CMultiTidyDlg::OnDblclkDirectory
* Inputs:
*       NMHDR * pNMHDR
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Displays the item
****************************************************************************/

void CMultiTidyDlg::OnDblclkDirectory(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();
    if(item == NULL)
       return;

    ShowTextItem(item);
        
    *pResult = 0;
   }

/****************************************************************************
*                      CMultiTidyDlg::OnDeleteDirectory
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Deletes an item from the file list
****************************************************************************/

void CMultiTidyDlg::OnDeleteitemDirectory(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    // TODO: Add your control notification handler code here
        
    *pResult = 0;
   }

/****************************************************************************
*                           CMultiTidyDlg::OnAbout
* Result: void
*       
* Effect: 
*       Pops up an About box
****************************************************************************/

void CMultiTidyDlg::OnAbout() 
   {
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
   }

/****************************************************************************
*                            CMultiTidyDlg::OnExit
* Result: void
*       
* Effect: 
*       Exits the program
****************************************************************************/

void CMultiTidyDlg::OnExit() 
   {
    CDialog::OnOK();
   }

/****************************************************************************
*                         CMultiTidyDlg::RegisterPath
* Inputs:
*       const CString & s: Name of path
* Result: void
*       
* Effect: 
*       Stores the file path
****************************************************************************/

void CMultiTidyDlg::RegisterPath(const CString & s)
    {
     TCHAR dev[_MAX_PATH];
     TCHAR path[_MAX_PATH];
     TCHAR filename[_MAX_PATH];
     TCHAR ext[_MAX_PATH];
     _tsplitpath(s, dev, path, filename, ext);
     TCHAR name[_MAX_PATH];
     _tmakepath(name, dev, path, NULL, NULL);
     
     RegistryString reg(IDS_REGISTRY_PATH);
     reg.value = name;
     reg.store();

    } // CMultiTidyDlg::RegisterPath

/****************************************************************************
*                            CMultiTidyDlg::OnOpen
* Result: void
*       
* Effect: 
*       Creates the file list
****************************************************************************/

void CMultiTidyDlg::OnOpen() 
   {
    CString filter;
    RegistryString path(IDS_REGISTRY_PATH);
    path.load();

    filter=_T("HTML files (*.htm;*.html)|*.htm;*.html|XML files (*.xml)|All files (*.*)|*.*||");
    CFileDialog dlg(TRUE, _T(".htm;.html"), NULL,
                    OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT | OFN_ENABLESIZING | OFN_EXPLORER | OFN_FILEMUSTEXIST,
                    filter);
#define MAX_BUFFER_SIZE (2048 * _MAX_PATH)
    LPTSTR buffer = new TCHAR[MAX_BUFFER_SIZE];
    dlg.m_ofn.lpstrFile = buffer;
    buffer[0] = _T('\0');
    dlg.m_ofn.nMaxFile = MAX_BUFFER_SIZE;
    
    dlg.m_ofn.lpstrInitialDir = path.value;
    
    if(dlg.DoModal() != IDOK)
       { /* failed */
        delete [ ] buffer;
        updateControls();
        return;
       } /* failed */

    POSITION p;
    int count = 0;
    p = dlg.GetStartPosition();
    while(p != NULL)
       { /* count items */
        dlg.GetNextPathName(p);
        count++;
       } /* count items */
    c_Progress.SetRange(0, count);
    c_Progress.SetPos(0);
    c_Progress.ShowWindow(SW_SHOW);
    c_Progress.SetStep(1);

    p = dlg.GetStartPosition();

    while(p != NULL)
       { /* read files */
        CString s = dlg.GetNextPathName(p);
        RegisterPath(s);
        AddItem(s);
        c_Progress.StepIt();
        c_Progress.UpdateWindow();
       } /* read files */

    delete [ ] buffer;
    c_Progress.ShowWindow(SW_HIDE);
    c_Directory.Invalidate();
    updateControls();
   }

/****************************************************************************
*                           CMultiTidyDlg::AddItem
* Inputs:
*       const CString & s: filename
* Result: void
*       
* Effect: 
*       Adds the item to the list control
****************************************************************************/

HTREEITEM CMultiTidyDlg::AddItem(const CString & s)
    {
     TCHAR file[_MAX_PATH];
     TCHAR ext[_MAX_PATH];
     TCHAR path[_MAX_PATH];
     TCHAR drive[_MAX_PATH];
     _tsplitpath(s, drive, path, file, ext);
     HTREEITEM devroot = AddDrive(drive);
     c_Directory.SetItemData(devroot, NodeType::Drive);
     c_Directory.SetItemImage(devroot, SymbolIcons::Drive, SymbolIcons::DriveSelected);
     LPCTSTR p = path;
     if(p[0] == _T('\\'))
         p++;

     HTREEITEM dirroot = AddPath(devroot, p);

     CString name = file;
     name += ext;
     
     HTREEITEM fileitem = InsertAlphabetically(dirroot, name);
     c_Directory.SetItemData(fileitem, NodeType::File);
     c_Directory.SetItemImage(fileitem, SymbolIcons::File, SymbolIcons::FileSelected);
     return devroot;
    } // CMultiTidyDlg::AddItem

/****************************************************************************
*                           CMultiTidyDlg::FindItem
* Inputs:
*       HTREEITEM root: Root of tree
*       const CString & s: String to find
* Result: HTREEITEM
*       Tree item, or NULL if not found
****************************************************************************/

HTREEITEM CMultiTidyDlg::FindItem(HTREEITEM root, const CString & s)
    {
     HTREEITEM r = c_Directory.GetNextItem(root, TVGN_CHILD);
     if(r == NULL)
        { /* does not exist */
         return NULL;
        } /* does not exist */

     while(true)
        { /* scan list */
         CString t = c_Directory.GetItemText(r);
         if(t == s)
            return r;
         HTREEITEM next = c_Directory.GetNextSiblingItem(r);
         if(next == NULL)
            return NULL;
         r = next;
        } /* scan list */

     return NULL;
    } // CMultiTidyDlg::FindItem

/****************************************************************************
*                     CMultiTidyDlg::InsertAlphabetically
* Inputs:
*       HTREEITEM root
*       const CString & s: String to insert
* Result: HTREEITEM
*       The item added
* Effect: 
*       Adds the item to the tree
****************************************************************************/

HTREEITEM CMultiTidyDlg::InsertAlphabetically(HTREEITEM root, const CString & s)
    {
     HTREEITEM item = FindItem(root, s);
     if(item != NULL)
        return item;
     return c_Directory.InsertItem(s, root, TVI_SORT);
    } // CMultiTidyDlg::InsertAlphabetically

/****************************************************************************
*                           CMultiTidyDlg::AddDrive
* Inputs:
*       const CString & s: Drive letter
* Result: HTREEITEM
*       The tree item for the drive
* Effect: 
*       Adds the drive to the tree
****************************************************************************/

HTREEITEM CMultiTidyDlg::AddDrive(const CString & s)
    {
     return InsertAlphabetically(TVI_ROOT, s);
    } // CMultiTidyDlg::AddDrive

/****************************************************************************
*                           CMultiTidyDlg::AddPath
* Inputs:
*       HTREEITEM r: Root of current path
*       const CString & s: Directory path
* Result: HTREEITEM
*       The item for the current level
* Effect: 
*       Adds as many items as needed
****************************************************************************/

HTREEITEM CMultiTidyDlg::AddPath(HTREEITEM r, const CString & s)
    {
     //   p1/p2/p3
     TCHAR path[_MAX_PATH];
     TCHAR file[_MAX_PATH];
     TCHAR ext[_MAX_PATH];
     CString p;
     if(s.Right(1) == _T("\\"))
         p = s.Left(s.GetLength() - 1);
     else
         p = s;
     _tsplitpath(p, NULL, path, file, ext);

     if(lstrlen(path) == 0)
        { /* terminal */
         CString name= file;
         name += ext;
         HTREEITEM item = InsertAlphabetically(r, name);
         c_Directory.SetItemData(item, NodeType::Directory);
         c_Directory.SetItemImage(item, SymbolIcons::Folder, SymbolIcons::FolderSelected);
         return item;
        } /* terminal */

     // We have the situation where the input was
     // something like
     //  p1/p2/p3
     // and at this point, we have
     // path: p1/p2
     // file: p3
     HTREEITEM item = AddPath(r, path);
     CString name = file;
     name += ext;
     HTREEITEM result = InsertAlphabetically(item, name);
     c_Directory.SetItemData(result, NodeType::Directory);
     c_Directory.SetItemImage(result, SymbolIcons::Folder, SymbolIcons::FolderSelected);
     return result;
    } // CMultiTidyDlg::AddPath

/****************************************************************************
*                         CMultiTidyDlg::GetFilePath
* Inputs:
*       HTREEITEM item:
* Result: CString
*       The complete file path
****************************************************************************/

CString CMultiTidyDlg::GetFilePath(HTREEITEM item)
    {
     CString name = c_Directory.GetItemText(item);

     HTREEITEM r = c_Directory.GetParentItem(item);
     while(r != NULL)
        { /* form path */
         CString step = c_Directory.GetItemText(r);
         name = step + _T("\\") + name;
         r = c_Directory.GetParentItem(r);
        } /* form path */
     return name;
    } // CMultiTidyDlg::GetFilePath

/****************************************************************************
*                          CMultiTidyDlg::AddErrors
* Inputs:
*       const CString & errstr: Error string
*       HTREEITEM item: Place to assign it
* Result: void
*       
* Effect: 
*       Adds the error, warning or info line
****************************************************************************/

void CMultiTidyDlg::AddErrors(HTREEITEM item, const CString & errstr)
    {
     CString s = errstr;
     s.Replace(_T("\r"), _T("")); // normalize end-of-line

     while(true)
        { /* scan string */
         if(s.IsEmpty())
            break;
         int n = s.Find(_T("\n"));
         if(n < 0)
            { /* last string */
             LogError(item, s);
             return;
            } /* last string */
         LogError(item, s.Left(n));
         s = s.Mid(n + 1);
        } /* scan string */
    } // CMultiTidyDlg::AddErrors

/****************************************************************************
*                           CMultiTidyDlg::TidyItem
* Inputs:
*       LPCTSTR buffer: Buffer to parse
*       HTREEITEM item: Item to be tidied
*       BOOL replace: Replace text
* Result: void
*       
* Effect: 
*       Tidies the item whose text is in the text control
****************************************************************************/

void CMultiTidyDlg::TidyItem(LPCTSTR buffer, HTREEITEM item, BOOL replace)
    {
     while(c_Directory.ItemHasChildren(item))
        { /* kill existing child nodes */
         HTREEITEM child = c_Directory.GetChildItem(item);
         c_Directory.DeleteItem(child);
        } /* kill existing child nodes */
     c_Directory.SetItemState(item, ErrorIcons::blank, TVIS_STATEIMAGEMASK);

     TidyBuffer errbuf = {0};
     TidyBuffer output = {0};
     int rc = -1;

     TidyDoc tdoc = tidyCreate();

     rc = tidySetErrorBuffer(tdoc, &errbuf);
     if(rc >= 0)
        rc = tidyParseString(tdoc, (LPCSTR)buffer);
     if(rc >= 0)
        rc = tidyCleanAndRepair(tdoc);
     if(rc >= 0)
        rc = tidyRunDiagnostics(tdoc);

     /*****************************************************************************
       To say that the documentation on the various libraries is exceptionally
       poor is to understate the situation. I'm sure there is an intelligent,
       responsible way to actually READ the data from errbuf, but I am unable
       to derive it from reading the poorly-written and largely uncommented code,
       or from the even more poorly-written documentation. So the hell with it,
       I have a job to do. This ghastly kludge would not be necessary if there
       were a simple primitive to read the contents of the TidyBuffer, but I
       can't find one that resets the position without clearing the data.
     *****************************************************************************/
#define GetErrorText(e)  (*((LPSTR*)&e))
     CString errstr = GetErrorText(errbuf);

     if(errstr.GetLength() > 0)
        AddErrors(item, errstr);

     if(replace && rc >= 0)
        { /* replace text */
         rc = (tidyOptSetBool(tdoc, TidyForceOutput, yes) ? rc : -1);
         if(rc >= 0)
            { /* save it */
             rc = tidySaveBuffer(tdoc, &output);
#define GetReplaceText(e) (*((LPTSTR*)&e))
             CString replacer = GetReplaceText(output);
             c_Text.SetWindowText(replacer);
            } /* save it */
        } /* replace text */

     tidyBufFree(&output);
     tidyBufFree(&errbuf);
     tidyRelease(tdoc);

     if((c_Directory.GetItemState(item, TVIS_STATEIMAGEMASK) & TVIS_STATEIMAGEMASK) == (UINT)INDEXTOSTATEIMAGEMASK(ErrorIcons::blank))
        c_Directory.SetItemState(item, INDEXTOSTATEIMAGEMASK(ErrorIcons::ok), TVIS_STATEIMAGEMASK);
     
    } // CMultiTidyDlg::TidyItem

/****************************************************************************
*                         CMultiTidyDlg::ProcessItem
* Inputs:
*       HTREEITEM item: Item to process
*       BOOL load (=FALSE): TRUE to load text into window; FALSE to not load it
* Result: void
*       
* Effect: 
*       Processes the file represented by the item
****************************************************************************/

void CMultiTidyDlg::ProcessItem(HTREEITEM item, BOOL load)
    {
     CString name;
     name = GetFilePath(item);
     CFile f;
     if(!f.Open(name, CFile::modeRead))
        { /* failed */
         DWORD err = ::GetLastError();
         LogError(item, err);
         return;
        } /* failed */

     LPBYTE buffer = new BYTE[f.GetLength() + sizeof(WCHAR)];
     f.Read(buffer, f.GetLength());
     // The odd expression below guarantees that even if the file is
     // Unicode, it will be properly NUL-terminated
     *(LPWSTR)(&buffer[f.GetLength()]) = L'0';
     f.Close();

     if(load)
        { /* load it */
         c_Text.SetWindowText((LPCTSTR)buffer);
         original = ComputeChecksum();
        } /* load it */
     TidyItem((LPCTSTR)buffer, item, FALSE);
     delete [ ] buffer;
    } // CMultiTidyDlg::ProcessItem

/****************************************************************************
*                        CMultiTidyDlg::LoadAndProcess
* Inputs:
*       HTREEITEM Item: Item to process
* Result: void
*       
* Effect: 
*       Loads and processes the data
****************************************************************************/

void CMultiTidyDlg::LoadAndProcess(HTREEITEM item)
    {
     CString name = GetFilePath(item);
     CString buffer;
     if(name != CurrentFile)
        { /* force load */
         if(!CurrentFile.IsEmpty())
         { /* live file */
         switch(CheckModified())
            { /* modified */
             case IDYES:
                if(!DoSave(CurrentFile))
                   return;
                break;
             case IDNO:
                break;
             case IDCANCEL:
                return;
            } /* modified */
         } /* live file */
         ProcessItem(item, TRUE);
        } /* force load */
     else
        { /* already loaded */
         c_Text.GetWindowText(buffer);
         TidyItem(buffer, item, FALSE); // Now recompute the state, based on the new text
        } /* already loaded */
    } // LoadAndProcess

/****************************************************************************
*                           CMultiTidyDlg::LogError
* Inputs:
*       HTREEITEM item: Item to which error is attached
*       const CString & err: Error string
* Result: void
*       
* Effect: 
*       Attaches the error message to the file node
****************************************************************************/

void CMultiTidyDlg::LogError(HTREEITEM item, CString & err)
    {
     // line n column m - Warning: xxxxxxxx
     // line n column m - Error: xxxxxxx
     // Info: xxxxxxx

     // parse line n, column m
     int p;
     int n = 0;
     int m = 0;

     CString t = err;

     if(err.IsEmpty())
         return; // ignore empty lines

     p = t.Find("This document has errors");
     if(p >= 0)
         return;
     p = t.Find("using HTML Tidy");
     if(p >= 0)
         return;
     
     p = t.Find(_T(" "));
     if(p < 0)
        return; // not a known error message

     if(t.Left(p) == _T("line"))
        { /* have line */
         t = t.Mid(p);
         t.TrimLeft();
         n = atoi(t);
         p = t.Find(_T(" "));
         if(p < 0 && n != 0)
            return; // not a known error message: "line nn blah blah blah
                    // expecting                  "line nn column mm - 

         t = t.Mid(p);
         t.TrimLeft();

         p = t.Find(_T(" "));
         if(p < 0 && n != 0)
            return; // not a known error message: "line nn blah blah blah

         if(t.Left(p) == _T("column"))
            { /* have column */
             t = t.Mid(p);
             t.TrimLeft();
             m = atoi(t);
            } /* have column */
         if(n > 0 && m > 0)
            { /* handle sorting */
             p = t.Find(_T("-"));
             if(p < 0)
                { /* not valid error message */
                 n = m = 0;
                } /* not valid error message */
             else
                { /* valid error messsage */
                 t = t.Mid(p + 1);
                 t.TrimLeft();
                 CString lc;
                } /* valid error messsage */
            } /* handle sorting */
        } /* have line */

     Error error(n, m, t);

     err = error.MakeString();
     if(filters.IsFiltered(error.text))
        return; // filtered error

     p = err.Find(_T("Warning:"));
     if(p >= 0)
        { /* warning */
         HTREEITEM r = c_Directory.InsertItem(err, item, TVI_SORT);
         c_Directory.SetItemData(r, NodeType::Message);
         SetState(r, ErrorIcons::warning);
         c_ErrorSummary.AddString(error, ErrorIcons::warning);
         return;
        } /* warning */

     p = err.Find(_T("Error:"));
     if(p >= 0)
        { /* error */
         HTREEITEM r = c_Directory.InsertItem(err, item, TVI_SORT);
         c_Directory.SetItemData(r, NodeType::Message);
         SetState(r, ErrorIcons::error);
         c_ErrorSummary.AddString(error, ErrorIcons::error);
         return;
        } /* error */

     p = err.Find(_T("Info"));
     if(p >= 0)
        { /* info */
         HTREEITEM r = c_Directory.InsertItem(err, item, TVI_SORT);
         c_Directory.SetItemData(r, NodeType::Message);
         SetState(r, ErrorIcons::info);
         c_ErrorSummary.AddString(error, ErrorIcons::info);
         return;
        } /* info */

     p = err.Find(_T("were found"));
     if(p >= 0)
         return; // ignore this line
     ASSERT(FALSE); // something else, figure it out
    } // CMultiTidyDlg::LogError

/****************************************************************************
*                           CMultiTidyDlg::LogError
* Inputs:
*       HTREEITEM item: item to which error is attached
*       DWORD err: System error code
* Result: void
*       
* Effect: 
*       Attaches the error message to the file node
****************************************************************************/

void CMultiTidyDlg::LogError(HTREEITEM item, DWORD err)
    {
     CString s = ErrorString(err);
     HTREEITEM r = c_Directory.InsertItem(s, item, TVI_SORT);
     c_Directory.SetItemData(r, NodeType::Message);
    } // CMultiTidyDlg::LogError


/****************************************************************************
*                          CMultiTidyDlg::CountFiles
* Inputs:
*       HTREEITEM item: Item to walk.
* Result: int
*       Count of files found at this level and all sublevels
****************************************************************************/

int CMultiTidyDlg::CountFiles(HTREEITEM item)
    {
     int count = 0;
     if(item == NULL)
        return 0;
     NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
     HTREEITEM r;
     switch(data)
        { /* node type */
         case NodeType::Drive:
         case NodeType::Directory:
               r = c_Directory.GetChildItem(item);
               if(r == NULL)
                  return count; // error, should ASSERT
               count += CountFiles(r);
               break;
         case NodeType::File:
               count++;
               break;
        } /* node type */

     r = c_Directory.GetNextSiblingItem(item);
     if(r != NULL)
        count += CountFiles(r);
     return count;
    } // CMultiTidyDlg::CountFiles

/****************************************************************************
*                           CMultiTidyDlg::DoTidy
* Inputs:
*       HTREEITEM item: Item to handle
* Result: void
*       
* Effect: 
*       If the item is a leaf of the tree, go process the file
*       If it is not a leaf, recurse
****************************************************************************/

void CMultiTidyDlg::DoTidy(HTREEITEM item)
    {
    if(item == NULL)
        return;
     NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
     HTREEITEM r;
     
     switch(data)
        { /* node type */
         case NodeType::Drive:
         case NodeType::Directory:
               r = c_Directory.GetChildItem(item);
               if(r == NULL)
                  return; // error, should ASSERT
               DoTidy(r);
               break;
         case NodeType::File:
               c_Progress.StepIt();
               c_Progress.UpdateWindow();
               ProcessItem(item, FALSE);
               break;
        } /* node type */

     r = c_Directory.GetNextSiblingItem(item);
     if(r != NULL)
        DoTidy(r);
    } // CMultiTidyDlg::DoTidy

/****************************************************************************
*                            CMultiTidyDlg::OnTidy
* Result: void
*       
* Effect: 
*       Tidies all the files
****************************************************************************/

void CMultiTidyDlg::OnTidy() 
   {
    c_ErrorSummary.ResetContent();
    CString s;
    s.LoadString(IDS_ERROR_SUMMARY);
    Error error(0,0, s);
    c_ErrorSummary.AddString(error, ErrorIcons::blank);
    c_ErrorSummary.SetCurSel(0);

    int n = CountFiles(c_Directory.GetChildItem(TVI_ROOT));

    c_Progress.SetPos(0);
    c_Progress.SetRange(0, n);
    c_Progress.ShowWindow(SW_SHOW);
    DoTidy(c_Directory.GetChildItem(TVI_ROOT));
    c_Progress.ShowWindow(SW_HIDE);
   }

/****************************************************************************
*                         CMultiTidyDlg::OnFileClear
* Result: void
*       
* Effect: 
*       Removes all the items from the list
****************************************************************************/

void CMultiTidyDlg::OnFileClear() 
   {
    c_Directory.DeleteAllItems();      
    updateControls();
   }

/****************************************************************************
*                       CMultiTidyDlg::OnInitMenuPopup
* Inputs:
*       CMenu * pPopupMenu: ignored
*       UINT nIndex: ignored
*       BOOL bSysMenu: ignored
* Result: void
*       
* Effect: 
*       Enables/disables controls
****************************************************************************/

void CMultiTidyDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
   {
    updateControls();
    CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
   }

/****************************************************************************
*                      CMultiTidyDlg::EnableFileOptions
* Inputs:
*       CMenu * menu: Menu
* Result: void
*       
* Effect: 
*       Enables the file menu options
****************************************************************************/

void CMultiTidyDlg::EnableFileOptions(CMenu * menu)
    {
     BOOL exists = !CurrentFile.IsEmpty();
     BOOL modified = c_Text.GetModify();
     menu->EnableMenuItem(IDM_SAVE, MF_BYCOMMAND |  exists && modified ? MF_ENABLED : MF_GRAYED);
     menu->EnableMenuItem(IDM_SAVE_AS, MF_BYCOMMAND |  exists ? MF_ENABLED : MF_GRAYED);
    } // CMultiTidyDlg::EnableFileOptions

/****************************************************************************
*                        CMultiTidyDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CMultiTidyDlg::updateControls()
    {
     CMenu * menu = GetMenu();
     BOOL enable;

     enable = c_Directory.GetCount() > 0;

     menu->EnableMenuItem(IDM_FILE_CLEAR, MF_BYCOMMAND | (enable ? MF_ENABLED : MF_GRAYED));
     menu->EnableMenuItem(IDM_TIDY, MF_BYCOMMAND | (enable ? MF_ENABLED : MF_GRAYED));
     menu->EnableMenuItem(IDM_EXPAND_ALL, MF_BYCOMMAND | (enable ? MF_ENABLED : MF_GRAYED));

     menu->CheckMenuItem(IDM_USE_FILTERS, UseFilters ? MF_CHECKED : MF_UNCHECKED);
     DrawMenuBar();

     Checksum chk = ComputeChecksum();
     c_Text.SetModify(chk != original);

     BOOL modified = c_Text.GetModify();
     EnableFileOptions(menu);
     c_Changed.SetWindowText(modified ? _T("*") : _T(""));

     UINT show = CurrentFile.IsEmpty() ? SW_HIDE : SW_SHOW;
     c_Title.ShowWindow(show);
     c_ErrorMessage.ShowWindow(show);
     c_Text.ShowWindow(show);
     c_Text.EnableWindow(!CurrentFile.IsEmpty());

     c_ErrorSummary.ShowWindow(c_ErrorSummary.GetCount() > 1 ? SW_SHOW : SW_HIDE);
    } // CMultiTidyDlg::updateControls

/****************************************************************************
*                          CMultiTidyDlg::InDragArea
* Inputs:
*       CPoint pt: Cursor position in client coordinates
* Result: BOOL
*       TRUE if in drag area
*       FALSE if not
****************************************************************************/

BOOL CMultiTidyDlg::InDragArea(CPoint pt)
    {
     CRect LHW;
     c_Directory.GetWindowRect(&LHW);
     ScreenToClient(&LHW);

     CRect RHW;
     c_Text.GetWindowRect(&RHW);
     ScreenToClient(&RHW);

     if(LHW.right <= pt.x && pt.x < RHW.left &&
        pt.y > LHW.top && pt.y < LHW.bottom)
        return TRUE;
     return FALSE;
    } // CMultiTidyDlg::InDragArea

/****************************************************************************
*                         CMultiTidyDlg::OnSetCursor
* Inputs:
*       CWnd * pWnd: ignored
*       UINT nHitTest: only HTCLIENT matters
*       UINT message: 
* Result: BOOL
*       TRUE if cursor was set
* Effect: 
*       If in drag area, sets the cursor
****************************************************************************/

BOOL CMultiTidyDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
   {
    if(nHitTest == HTCLIENT)
       { /* client hit */
        CPoint pt;
        GetCursorPos(&pt);
        ScreenToClient(&pt);
        if(InDragArea(pt))
           { /* drag option */
            SetCursor(dragger);
            return TRUE;
           } /* drag option */
       } /* client hit */
        
    return CDialog::OnSetCursor(pWnd, nHitTest, message);
   }

/****************************************************************************
*                        CMultiTidyDlg::OnLButtonDown
* Inputs:
*       UINT nFlags: ignored
*       CPoint point: Client coordinates of mouse down
* Result: void
*       
* Effect: 
*       Starts a drag operation
****************************************************************************/

void CMultiTidyDlg::OnLButtonDown(UINT nFlags, CPoint point) 
   {
    if(InDragArea(point))
       { /* start drag */
        SetCursor(drag);
        SetCapture();
        DragPoint = point;

        CRect r;
        GetClientRect(&r);
        CRect clip = r;

        clip.left = MIN_WINDOW_SIZE;
        clip.right = r.Width() - MIN_WINDOW_SIZE;
        ClientToScreen(&clip);
        ::ClipCursor(&clip);
        return;
       } /* start drag */
        
    CDialog::OnLButtonDown(nFlags, point);
   }

/****************************************************************************
*                         CMultiTidyDlg::OnLButtonUp
* Inputs:
*       UINT nFlags: ignored
*       CPoint point: Client coordinates of point
* Result: void
*       
* Effect: 
*       Release capture if it was owned
****************************************************************************/

void CMultiTidyDlg::OnLButtonUp(UINT nFlags, CPoint point) 
   {
    if(GetCapture() != NULL)
       { /* release capture */
        ReleaseCapture();
        ::ClipCursor(NULL);
       } /* release capture */
    CDialog::OnLButtonUp(nFlags, point);
   }

/****************************************************************************
*                         CMultiTidyDlg::OnMouseMove
* Inputs:
*       UINT nFlags: flags
*       CPoint point: Current point in client coordinates
* Result: void
*       
* Effect: 
*       Resizes the window
****************************************************************************/

void CMultiTidyDlg::OnMouseMove(UINT nFlags, CPoint point) 
   {
    if(GetCapture() != NULL)
       { /* drag it */
        int dx = DragPoint.x - point.x;
        
        CRect LHW;
        c_Directory.GetWindowRect(&LHW);
        ScreenToClient(&LHW);

        CRect RHW;
        c_Text.GetWindowRect(&RHW);
        ScreenToClient(&RHW);

        LHW.right -= dx;
        RHW.left -= dx;

        c_Directory.SetWindowPos(NULL,
                                 0, 0,
                                 LHW.Width(),
                                 LHW.Height(),
                                 SWP_NOMOVE | SWP_NOZORDER);
        c_Text.SetWindowPos(NULL,
                            RHW.left, RHW.top,
                            RHW.Width(), RHW.Height(),
                            SWP_NOZORDER);
        SizeTextCompanions();
        DragPoint = point;
       } /* drag it */

    CDialog::OnMouseMove(nFlags, point);
   }

/****************************************************************************
*                      CMultiTidyDlg::OnRclickDirectory
* Inputs:
*       NMHDR * pNMHdr:
*       LRESULT * pResult: always set to 0
* Result: void
*       
* Effect: 
*       Pops up appropriate right-click menu
****************************************************************************/

void CMultiTidyDlg::OnRclickDirectory(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    *pResult = 0;

    HTREEITEM sel = c_Directory.GetSelectedItem();

    if(sel == NULL)
       return; // nothing selected

    NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(sel);

    CMenu popup;
    CPoint pt;

    switch(data)
       { /* Node Type */
        case NodeType::Message:
              popup.LoadMenu(IDR_MSG_POPUP);
              GetCursorPos(&pt);
              popup.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, pt.x, pt.y, this);
              break;
        case NodeType::File:
             { /* file */
              CString name = GetFilePath(sel);
              BOOL same = name == CurrentFile;

              popup.LoadMenu(IDR_FILE_POPUP);
              GetCursorPos(&pt);
              BOOL exists = !CurrentFile.IsEmpty();
              BOOL modified = c_Text.GetModify();
              CMenu * menu = popup.GetSubMenu(0);

              menu->EnableMenuItem(IDM_SAVE_THIS, MF_BYCOMMAND |  (same && exists && modified ? MF_ENABLED : MF_GRAYED));
              menu->EnableMenuItem(IDM_SAVE_THIS_AS, MF_BYCOMMAND |  (same && exists ? MF_ENABLED : MF_GRAYED));
              menu->EnableMenuItem(IDM_REPLACE, MF_BYCOMMAND | (exists ? MF_ENABLED : MF_GRAYED));

              if(exists)
                 menu->DeleteMenu(IDM_TIDY_THIS, MF_BYCOMMAND);
              else
                 menu->DeleteMenu(IDM_RETIDY, MF_BYCOMMAND);
              
              menu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, pt.x, pt.y, this);
             } /* file */
             break;
       } /* Node Type */
   }

/****************************************************************************
*                            CMultiTidyDlg::OnShow
* Result: void
*       
* Effect: 
*       Shows the error
****************************************************************************/

void CMultiTidyDlg::OnShow() 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();
    if(item == NULL)
       return;

    ShowTextItem(item);
   }

void CMultiTidyDlg::OnIgnore() 
   {
    // TODO: Add your command handler code here
   }

/****************************************************************************
*                         CMultiTidyDlg::OnChangeText
* Result: void
*       
* Effect: 
*       Updates the controls based on changes to the text.
****************************************************************************/

void CMultiTidyDlg::OnChangeText() 
   {
    updateControls();
   }

/****************************************************************************
*                         CMultiTidyDlg::ComputeChecksum
* Result: Checksum
*       A computed checksum on the text contents
****************************************************************************/

Checksum CMultiTidyDlg::ComputeChecksum()
    {
     Checksum chk;
     CString s;
     c_Text.GetWindowText(s);
     chk.Add(s);
     return chk;
    } // CMultiTidyDlg::Checksum

/****************************************************************************
*                            CMultiTidyDlg::OnSave
* Result: void
*       
* Effect: 
*       Saves the current text
****************************************************************************/

void CMultiTidyDlg::OnSave() 
   {
    DoSave(CurrentFile);
   }

/****************************************************************************
*                        CMultiTidyDlg::CheckModified
* Result: int
*       IDYES to save
*       IDNO to discard changes, or if there are no changes to save
*       IDCANCEL to terminate processing
* Effect: 
*       Prompts use for save changes? [Yes][No][Cancel]
****************************************************************************/

BOOL CMultiTidyDlg::CheckModified()
    {
     if(c_Text.GetModify())
        { /* save? */
         return AfxMessageBox(IDS_QUERY_SAVE, MB_YESNOCANCEL | MB_ICONQUESTION);
        } /* save? */
     return IDNO;
    } // CMultiTidyDlg::CheckModified

/****************************************************************************
*                            CMultiTidyDlg::DoSave
* Inputs:
*       const CString & name: File name to save
* Result: BOOL
*       TRUE if save was successful
*       FALSE if save had error
* Effect: 
*       Saves the file under the indicated name.
****************************************************************************/

BOOL CMultiTidyDlg::DoSave(const CString & name)
    {
     CFile f;
     if(!f.Open(name, CFile::modeWrite | CFile::modeCreate))
        { /* file open failed */
         DWORD err = ::GetLastError();
         CString fmt;
         fmt.LoadString(IDS_OPEN_FAILURE);
         CString msg;
         msg.Format(fmt, name, ErrorString(err));
         AfxMessageBox(msg, MB_OK | MB_ICONERROR);
         return FALSE;
        } /* file open failed */

     CString s;
     c_Text.GetWindowText(s);

     f.Write((LPCTSTR)s, s.GetLength() * sizeof(TCHAR));
     f.Close();
     c_Text.SetModify(FALSE);
     original = ComputeChecksum();
     updateControls();
     return TRUE;
    } // CMultiTidyDlg::DoSave

/****************************************************************************
*                           CMultiTidyDlg::DoSaveAs
* Result: BOOL
*       TRUE if saved successfull
*       FALSE if save failed
* Effect: 
*       Saves the file and changes its name
****************************************************************************/

BOOL CMultiTidyDlg::DoSaveAs()
    {
     CString defext = _T(".htm");
     CString filter;
     filter.LoadString(IDS_HTML_FILTER);
     TCHAR ext[MAX_PATH];
     _tsplitpath(CurrentFile, NULL, NULL, NULL, ext);
     if(lstrlen(ext) != 0)
        defext = ext;
     
     CFileDialog dlg(FALSE, defext, CurrentFile,
                     OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                     filter);
     if(dlg.DoModal() != IDOK)
        return FALSE;
     CString file = dlg.GetPathName();
     if(!DoSave(file))
        return FALSE;
     CurrentFile = file;
     return TRUE;
    } // CMultiTidyDlg::DoSaveAs

/****************************************************************************
*                         CMultiTidyDlg::ShowTextItem
* Inputs:
*       HTREEITEM item: Item whose text is to be shown
* Result: void
*       
* Effect: 
*       If the file is not loaded, loads it.
*       Shows the line and character of the error
****************************************************************************/

void CMultiTidyDlg::ShowTextItem(HTREEITEM item)
    {
     NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
     CString name;
     switch(data)
        { /* node type */
         case NodeType::Unknown:
            return;
         case NodeType::Drive:
            return;
         case NodeType::Directory:
            return;
         case NodeType::File:
            name = GetFilePath(item);
            break;
         case NodeType::Message:
            name = GetFilePath(c_Directory.GetParentItem(item));
            break;
        } /* node type */            

     if(name != CurrentFile)
        { /* load new file */
         switch(CheckModified())
            { /* action */
             case IDYES:
                if(!DoSave(CurrentFile))
                   return;
                break;
             case IDNO:
                break;
             case IDCANCEL:
                return;
            } /* action */

         c_Text.SetWindowText(_T(""));
         CurrentFile = _T("");
         c_Text.SetModify(FALSE);
         original = ComputeChecksum();

         CFile f;
         if(!f.Open(name, CFile::modeRead))
            { /* failed */
             DWORD err = ::GetLastError();
             // Unable to open file
             // %s
             // %s
             CString fmt;
             fmt.LoadString(IDS_OPEN_FAILURE);
             CString msg;
             msg.Format(fmt, name, ErrorString(err));
             AfxMessageBox(msg, MB_OK | MB_ICONERROR);
             updateControls();
             return;
            } /* failed */
         // File was opened successfully
         c_Title.SetWindowText(name);
         CString text;
         int len = f.GetLength();
         LPTSTR p = text.GetBuffer(len + 1);
         f.Read(p, len);
         p[len] = _T('\0');
         text.ReleaseBuffer();
         c_Text.SetWindowText(text);
         f.Close();
         CurrentFile = name;
         c_Text.SetModify(FALSE);
         original = ComputeChecksum();

        } /* load new file */
     // File is now loaded
     CString errmsg;
     errmsg = c_Directory.GetItemText(item);

     Error error;
     error.SplitString(errmsg);

     if(error.NoPos())
         c_Text.SetSel(0,0);
     else
        { /* has pos */
         int chpos = c_Text.LineIndex(error.line - 1);
         if(chpos < 0)
            chpos = c_Text.GetTextLength();

         chpos = min(chpos + error.column - 1, c_Text.GetTextLength());

         int chend = c_Text.LineIndex(error.line);
         if(chend < 0)
            chend = c_Text.GetTextLength();

         c_Text.SetSel(chpos, chend);
        } /* has pos */

     c_ErrorMessage.SetWindowText(error.text);

     updateControls();

    } // CMultiTidyDlg::ShowTextItem

/****************************************************************************
*                        CMultiTidyDlg::OnEditFilters
* Result: void
*       
* Effect: 
*       Edits the filter list
****************************************************************************/

void CMultiTidyDlg::OnEditFilters() 
   {
    CFilters dlg;
    dlg.filters = &filters;
    dlg.DoModal();
    RegistryString filter(IDS_REGISTRY_FILTERS);
    filter.load();
    if(!filter.value.IsEmpty())
       filters.Save(filter.value);
   }

/****************************************************************************
*                          CMultiTidyDlg::ExpandAll
* Inputs:
*       HTREEITEM item: Item to expand
* Result: void
*       
* Effect: 
*       Expands all items
****************************************************************************/

void CMultiTidyDlg::ExpandAll(HTREEITEM item, BOOL ExpandErrors)
    {
     if(item == NULL)
        return;
     NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
     HTREEITEM r;
     switch(data)
        { /* node type */
         case NodeType::Drive:
         case NodeType::Directory:
               c_Directory.Expand(item, TVE_EXPAND);
               r = c_Directory.GetChildItem(item);
               if(r == NULL)
                  return; // error, should ASSERT
               ExpandAll(r, ExpandErrors);
               break;
         case NodeType::File:
               if(ExpandErrors)
                    c_Directory.Expand(item, TVE_EXPAND);
               break;
        } /* node type */

     r = c_Directory.GetNextSiblingItem(item);
     ExpandAll(r, ExpandErrors);
    } // CMultiTidyDlg::ExpandAll

/****************************************************************************
*                         CMultiTidyDlg::OnExpandAll
* Result: void
*       
* Effect: 
*       Expands all the nodes down to but not including the file level
****************************************************************************/

void CMultiTidyDlg::OnExpandAll() 
   {
    ExpandAll(c_Directory.GetChildItem(TVI_ROOT), FALSE);
   }

/****************************************************************************
*                           CMultiTidyDlg::OnFilter
* Result: void
*       
* Effect: 
*       Called from the right-click "Add Filter" option from the directory
*       pane. Adds the current selection to the filter list, if it
*       isn't already there
****************************************************************************/

void CMultiTidyDlg::OnFilter() 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();

    NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
    switch(data)
       { /* data */
        case NodeType::Message:
           break;
        default:
           return;
       } /* data */

    CString errmsg = c_Directory.GetItemText(item);

    Error error;
    error.SplitString(errmsg);
    filters.Add(error.text);
   }

/****************************************************************************
*                         CMultiTidyDlg::OnUseFilters
* Result: void
*       
* Effect: 
*       Toggles the UseFilters flag
****************************************************************************/

void CMultiTidyDlg::OnUseFilters() 
   {
    UseFilters = !UseFilters;
   }

/****************************************************************************
*                       CMultiTidyDlg::ComputeFileIcon
* Inputs:
*       HTREEITEM item: Item to recompute
* Result: void
*       
* Effect: 
*       Recomputes the file icon
****************************************************************************/

void CMultiTidyDlg::ComputeFileIcon(HTREEITEM item)
    {
     SetState(item, ErrorIcons::ok);
     HTREEITEM r = c_Directory.GetChildItem(item);
     while(r != NULL)
        { /* recompute */
         ErrorIcons::icon state = (ErrorIcons::icon)STATEIMAGEMASKTOINDEX(c_Directory.GetItemState(r, TVIS_STATEIMAGEMASK) & TVIS_STATEIMAGEMASK);
         SetFileState(item, state);
         r = c_Directory.GetNextSiblingItem(r);
        } /* recompute */
    } // CMultiTidyDlg::ComputeFileIcon

/****************************************************************************
*                         CMultiTidyDlg::OnDeleteMsg
* Result: void
*       
* Effect: 
*       Deletes the message. Does not add it to filter list. Recomputes
*       the menu icon
****************************************************************************/

void CMultiTidyDlg::OnDeleteMsg() 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();
    NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
    switch(data)
       { /* data */
        case NodeType::Message:
              {
               HTREEITEM parent;
               parent = c_Directory.GetParentItem(item);
               c_Directory.DeleteItem(item);
               ComputeFileIcon(parent);
              }
              updateControls();
              break;
       } /* data */
        
   }

/****************************************************************************
*                         CMultiTidyDlg::OnRemoveFile
* Result: void
*       
* Effect: 
*       Removes the file from the file list
****************************************************************************/

void CMultiTidyDlg::OnRemoveFile() 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();
    NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
    switch(data)
       { /* data */
        case NodeType::File:
              c_Directory.DeleteItem(item);
              updateControls();
              break;
       } /* data */
   }

/****************************************************************************
*                          CMultiTidyDlg::OnReplace
* Result: void
*       
* Effect: 
*       Re-tidies the text and replaces the text with the tidied version
****************************************************************************/

void CMultiTidyDlg::OnReplace() 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();
    NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
    switch(data)
       { /* node type */
        case NodeType::File:
            {
             CString s;
             c_Text.GetWindowText(s);
             TidyItem(s, item, TRUE);
             c_Text.GetWindowText(s);
             TidyItem(s, item, FALSE); // Now recompute the state, based on the new text
             updateControls();
            }
              break;
       } /* node type */
   }

/****************************************************************************
*                           CMultiTidyDlg::OnRetidy
* Result: void
*       
* Effect: 
*       Reruns tidy on the contents of the buffer
****************************************************************************/

void CMultiTidyDlg::OnRetidy() 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();
    NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
    switch(data)
       { /* node type */
        case NodeType::File:
           { /* file */
            LoadAndProcess(item);
            updateControls();
           } /* file */
           break;
       } /* node type */
   }

/****************************************************************************
*                         CMultiTidyDlg::OnCloseFile
* Result: void
*       
* Effect: 
*       Closes the file
****************************************************************************/

void CMultiTidyDlg::OnCloseFile() 
   {
    switch(CheckModified())
       { /* modfied */
        case IDYES:
           if(!DoSave(CurrentFile))
              return;
           break;
        case IDNO:
           break;
        case IDCANCEL:
           return;
       } /* modfied */

    c_Text.SetWindowText(_T(""));
    CurrentFile = _T("");
    original = ComputeChecksum();
    updateControls();
   }

/****************************************************************************
*                         CMultiTidyDlg::OnSaveThisAs
* Result: void
*       
* Effect: 
*       Saves the current file
* Notes:
*       This will not activate if there is no current file
****************************************************************************/

void CMultiTidyDlg::OnSaveThisAs() 
   {
    DoSaveAs();
   }

/****************************************************************************
*                          CMultiTidyDlg::OnSaveThis
* Result: void
*       
* Effect: 
*       Saves the current file
****************************************************************************/

void CMultiTidyDlg::OnSaveThis() 
   {
    DoSave(CurrentFile);
   }

/****************************************************************************
*                          CMultiTidyDlg::OnTidyThis
* Result: void
*       
* Effect: 
*       Loads the file and tidies it
****************************************************************************/

void CMultiTidyDlg::OnTidyThis() 
   {
    HTREEITEM item = c_Directory.GetSelectedItem();
    NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
    switch(data)
       { /* node type */
        case NodeType::File:
              LoadAndProcess(item);
              updateControls();
              break;
       } /* node type */
   }

/****************************************************************************
*                        CMultiTidyDlg::OnSaveFilters
* Result: void
*       
* Effect: 
*       Saves the filter list
****************************************************************************/

void CMultiTidyDlg::OnSaveFilters() 
   {
    RegistryString filter(IDS_REGISTRY_FILTERS);
    filter.load();
    if(filters.Save(filter.value))
       { /* saved */
        filter.store();
       } /* saved */
   }

/****************************************************************************
*                        CMultiTidyDlg::OnExpandErrors
* Result: void
*       
* Effect: 
*       Expands the entire tree, including all error subtrees
****************************************************************************/

void CMultiTidyDlg::OnExpandErrors() 
   {
    HTREEITEM r = c_Directory.GetChildItem(TVI_ROOT);
    ExpandAll(r, TRUE);
   }

/****************************************************************************
*                          CMultiTidyDlg::CollapseErrors
* Inputs:
*       HTREEITEM item: Item to collapse
* Result: void
*       
* Effect: 
*       Collapses the error subtrees
****************************************************************************/

void CMultiTidyDlg::CollapseErrors(HTREEITEM item)
      {
      if(item == NULL)
         return;
      NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
      HTREEITEM r;
      switch(data)
         { /* node type */
          case NodeType::Drive:
          case NodeType::Directory:
                r = c_Directory.GetChildItem(item);
                if(r == NULL)
                   return; // error, should ASSERT
                CollapseErrors(r);
                break;
          case NodeType::File:
                c_Directory.Expand(item, TVE_COLLAPSE);
                break;
         } /* node type */

      r = c_Directory.GetNextSiblingItem(item);
      CollapseErrors(r);
      } // CMultiTidyDlg::ExpandAll

/****************************************************************************
*                       CMultiTidyDlg::OnCollapseErrors
* Result: void
*       
* Effect: 
*       Collapses all error subtrees
****************************************************************************/

void CMultiTidyDlg::OnCollapseErrors() 
   {
    HTREEITEM r = c_Directory.GetChildItem(TVI_ROOT);
    CollapseErrors(r);
   }

/****************************************************************************
*                          CMultiTidyDlg::DropClean
* Inputs:
*       HTREEITEM item: Item to clean
* Result: void
*       
* Effect: 
*       Drops all files which are marked as clean
****************************************************************************/

void CMultiTidyDlg::DropClean(HTREEITEM item)
    {
     if(item == NULL)
        return;
     NodeType::nodetype data = (NodeType::nodetype)c_Directory.GetItemData(item);
     HTREEITEM r;
     switch(data)
        { /* node type */
         case NodeType::Drive:
         case NodeType::Directory:
               r = c_Directory.GetChildItem(item);
               if(r == NULL)
                  return; // error, should ASSERT
               DropClean(r);
               r = NULL;
               break;
         case NodeType::File:
               r = c_Directory.GetNextSiblingItem(item);
               ErrorIcons::icon state =
                      (ErrorIcons::icon)STATEIMAGEMASKTOINDEX(c_Directory.GetItemState(item, TVIS_STATEIMAGEMASK) & TVIS_STATEIMAGEMASK);
               if(state == ErrorIcons::ok)
                  c_Directory.DeleteItem(item);
               break;
        } /* node type */

     if(r != NULL)
        DropClean(r);
    } // CMultiTidyDlg::DropClean

/****************************************************************************
*                         CMultiTidyDlg::OnDropClean
* Result: void
*       
* Effect: 
*       Walks the tree and drops all files which have been (a) tidied and
*       (b) determined to be clean
****************************************************************************/

void CMultiTidyDlg::OnDropClean() 
   {
    HTREEITEM r = c_Directory.GetChildItem(TVI_ROOT);
    DropClean(r);
   }
