// MultiTidyDlg.h : header file
//

#if !defined(AFX_MULTITIDYDLG_H__DD7EEBCE_F4B7_49D0_8A0C_DF183B74F6E4__INCLUDED_)
#define AFX_MULTITIDYDLG_H__DD7EEBCE_F4B7_49D0_8A0C_DF183B74F6E4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STATEIMAGEMASKTOINDEX(i) ( ((i) & LVIS_STATEIMAGEMASK) >> 12)

/////////////////////////////////////////////////////////////////////////////
// CMultiTidyDlg dialog
#include "Filter.h"
#include "Checksum.h"
#include "ErrorSummary.h"
#include "ErrorIcons.h"
#include "Error.h"

class SymbolIcons : public CImageList {
    public:
       typedef enum {
          None,
          Folder,
          FolderSelected,
          Drive,
          DriveSelected,
          File,
          FileSelected } icon;
};

namespace NodeType {
        typedef enum {
           Unknown = 0,
           Drive,
           Directory,
           File,
           Message } nodetype;
        }


class CMultiTidyDlg : public CDialog
{
// Construction
public:
        CMultiTidyDlg(CWnd* pParent = NULL);    // standard constructor

// Dialog Data
        //{{AFX_DATA(CMultiTidyDlg)
        enum { IDD = IDD_MULTITIDY_DIALOG };
        CErrorSummary   c_ErrorSummary;
        CStatic c_Title;
        CStatic c_ErrorMessage;
        CStatic c_Changed;
        CProgressCtrl   c_Progress;
        CRichEditCtrl   c_Text;
        CTreeCtrl       c_Directory;
        //}}AFX_DATA

        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CMultiTidyDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        CFont titlefont;
        HICON m_hIcon;
        HTREEITEM AddDrive(const CString & s);
        HTREEITEM AddItem(const CString & s);
        HTREEITEM InsertAlphabetically(HTREEITEM root, const CString & s);
        HTREEITEM AddPath(HTREEITEM root, const CString & s);
        HTREEITEM FindItem(HTREEITEM root, const CString & s);
        void RegisterPath(const CString & s);
        void updateControls();
        HCURSOR dragger;
        HCURSOR drag;
        CPoint DragPoint;
        BOOL InDragArea(CPoint pt);
        void DoTidy(HTREEITEM item);
        void ProcessItem(HTREEITEM item, BOOL load = FALSE);
        CString GetFilePath(HTREEITEM item);
        void LogError(HTREEITEM item, DWORD err);
        void LogError(HTREEITEM item, CString & s);
        void AddErrors(HTREEITEM item, const CString & errstr);
        ErrorIcons imagelist;
        SymbolIcons iconlist;
        void SetState(HTREEITEM item, ErrorIcons::icon state);
        void LoadAndProcess(HTREEITEM item);
        void ShowTextItem(HTREEITEM item);
        Checksum original;
        CString CurrentFile;
        Checksum ComputeChecksum();
        void SizeTextCompanions();
        BOOL UseFilters;
        int CountFiles(HTREEITEM item);
        BOOL CheckModified();
        BOOL DoSave(const CString & name);
        BOOL DoSaveAs();
        void EnableFileOptions(CMenu * menu);
        void TidyItem(LPCTSTR buffer, HTREEITEM item, BOOL replace);
        void ComputeFileIcon(HTREEITEM item);
        void SetFileState(HTREEITEM item, ErrorIcons::icon state);
        void ExpandAll(HTREEITEM item, BOOL ExpandErrors);
        void DropClean(HTREEITEM item);
        void CollapseErrors(HTREEITEM item);

        Filter filters;

        // Generated message map functions
        //{{AFX_MSG(CMultiTidyDlg)
        virtual BOOL OnInitDialog();
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        virtual void OnCancel();
        virtual void OnOK();
        afx_msg void OnClose();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
        afx_msg void OnDblclkDirectory(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnDeleteitemDirectory(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnAbout();
        afx_msg void OnExit();
        afx_msg void OnOpen();
        afx_msg void OnTidy();
        afx_msg void OnFileClear();
        afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
        afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
        afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
        afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
        afx_msg void OnMouseMove(UINT nFlags, CPoint point);
        afx_msg void OnRclickDirectory(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnShow();
        afx_msg void OnIgnore();
        afx_msg void OnChangeText();
        afx_msg void OnSave();
        afx_msg void OnEditFilters();
        afx_msg void OnExpandAll();
        afx_msg void OnFilter();
        afx_msg void OnUseFilters();
        afx_msg void OnDeleteMsg();
        afx_msg void OnRemoveFile();
        afx_msg void OnReplace();
        afx_msg void OnRetidy();
        afx_msg void OnCloseFile();
        afx_msg void OnSaveThisAs();
        afx_msg void OnSaveThis();
        afx_msg void OnTidyThis();
        afx_msg void OnSaveFilters();
        afx_msg void OnExpandErrors();
        afx_msg void OnCollapseErrors();
        afx_msg void OnDropClean();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTITIDYDLG_H__DD7EEBCE_F4B7_49D0_8A0C_DF183B74F6E4__INCLUDED_)
