/*****************************************************************************
*           Change Log
*  Date     | Change
*-----------+-----------------------------------------------------------------
*  3-Jun-99 | Created
*  3-Jun-99 | FBG #210: DWordArray values overloaded on UINT for IDS_name
* 11-Jun-99 | FBG #263: Added operations to support FBG #263
* 23-Mar-04 | FBG #334: Added functions from newer versions of the file
* 24-Mar-04 | PPR #1303: Added support to get key path
* 24-Mar-04 | PPR #1377: Added font support
* 26-Mar-04 | FBG #340: Upgraded to new versions of EnumRegistryKeys,
*           | EnumRegistryValues, Set/SetRegistryDWordArray
*****************************************************************************/
BOOL GetRegistryString(HKEY root, const CString &var, CString &val);
BOOL SetRegistryString(HKEY root, const CString &var, const CString &val);

BOOL GetRegistryString(HKEY root, const CString &path, const CString &var, CString &val);
BOOL SetRegistryString(HKEY root, const CString &path, const CString &var, const CString &val);
BOOL GetRegistryString(HKEY root, const CString &path, UINT var, CString &val);
BOOL SetRegistryString(HKEY root, const CString &path, UINT var, const CString &val);

BOOL GetRegistryInt(HKEY root, const CString &var, DWORD &val);
BOOL SetRegistryInt(HKEY root, const CString &var, DWORD val);
BOOL GetRegistryInt(HKEY root, const CString &path, const CString &var, DWORD & val);
BOOL SetRegistryInt(HKEY root, const CString &path, const CString &var, DWORD val);
BOOL GetRegistryInt(HKEY root, const CString &path, UINT var, DWORD &val);
BOOL SetRegistryInt(HKEY root, const CString &path, UINT var, DWORD val);

BOOL GetRegistryGUID(HKEY root, const CString &var, GUID &val);
BOOL SetRegistryGUID(HKEY root, const CString &var, const GUID &val);

BOOL DeleteRegistryValue(HKEY root, const CString & var);
BOOL DeleteRegistryKey(HKEY root, const CString & keyname);

BOOL GetRegistryKey(HKEY root, const CString & name, HKEY & key, DWORD access = KEY_ALL_ACCESS);// REG #012
BOOL FindRegistryKey(HKEY root, const CString & keyname, HKEY & key, DWORD access = KEY_ALL_ACCESS);// REG #012

BOOL EnumRegistryKeys(HKEY root, const CString & group, CStringArray & keys);// FBG #340
BOOL EnumRegistryValues(HKEY root, const CString & group, CStringArray & keys);// FBG #340

BOOL GetRegistryDWordArray(HKEY root, const CString &var, CDWordArray & data);// FBG #340
BOOL GetRegistryDWordArray(HKEY root, UINT id, CDWordArray & data);            // FBG #210// FBG #340
BOOL SetRegistryDWordArray(HKEY root, const CString & var, const CDWordArray & data);// FBG #340
BOOL SetRegistryDWordArray(HKEY root, UINT var, const CDWordArray & data);// FBG #210// FBG #340

BOOL SetRegistryDWordArray(HKEY root, const CString & var, CDWordArray & data);

BOOL CreateKey(HKEY root, const CString & key, DWORD access = KEY_ALL_ACCESS); // FBG #263// REG #012
HKEY OpenKey(HKEY root, const CString & path, DWORD access = KEY_ALL_ACCESS); // FBG #263// REG #012

CString GetKeyPath(const CString & key);                           // PPR #1303
CString GetKeyPath(UINT key);                                      // PPR #1303

BOOL GetRegistryFont(HKEY root, const CString & var, LPLOGFONT f); // PPR #1377
BOOL SetRegistryFont(HKEY root, const CString & var, const LOGFONT * f);// PPR #1377

BOOL GetRegistryWindowPlacement(HKEY root, const CString & var, WINDOWPLACEMENT * wp);// REQ #088
BOOL SetRegistryWindowPlacement(HKEY root, const CString & var, const WINDOWPLACEMENT * wp);// REQ #088
